package HumanCompare;

import java.io.File;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

import domain.AllData;

/**
 * Frame for entering Human Judge information
 * 
 * @author David Smith
 *
 */
public class FHJudge extends JFrame {
	
	public FHJudge(int sampleSize) throws IOException {
		createHumanJudgeFile(sampleSize);
	}
	
	public static void createHumanJudgeFile(int sampleSize) throws IOException {
		File[] files;
		AllData[] data;
		String[] names;
		
		//get output file
		File out = FHJudgeUtil.getOutFile();
		if (out == null) {
			return;
		}
		
		//get inputs
		files = getOpenFile();
		names = FHJudgeUtil.getNames(files);
		
		if (files == null) {
			JOptionPane.showMessageDialog(null, "Nothing selected. No output created.");
			return;
		}
		if (files.length < 2) {
			JOptionPane.showMessageDialog(null, "Need to select at least two scripts.");
			return;
		}
		data = FHJudgeUtil.getAllDatas(files);
		if (data == null)
			return;
		
		if (FHJudgeUtil.CreateFile(data, names, out, sampleSize))
			JOptionPane.showMessageDialog(null, "File successfully written to " + out.getName());
	}

	private static File[] getOpenFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("JSON Files", "json", "zip");
		fc.setFileFilter(filter);
		fc.setMultiSelectionEnabled(true);
		fc.setDialogTitle("Open Lined Scripts");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFiles();
		}
		else
			return null;
	}
	
	public static File getWriteFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("CSV Files", "csv");
		File file = new File("out.csv");
        fc.setSelectedFile(file);
		fc.setFileFilter(filter);
		fc.setDialogTitle("Create CSV File");
		fc.setApproveButtonText("New");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		}
		else
			return null;
	}
	
}
