package comparer;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import lister.TargetFeature;

public class CResultsFrame extends JFrame {

	JPanel pane;
	JPanel filePane;
	JLabel file1;
	JLabel file2;
	JPanel resultsPane;
	JLabel cut;
	JLabel shot;
	JLabel clean;
	JLabel motion;
	JLabel total;
	
	public CResultsFrame(Comparison c) {
		setTitle("Comparison Results");
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(20,30,20,30));
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		file1 = new JLabel("File 1: " + c.getFile1());
		file2 = new JLabel("File 2: " + c.getFile2());
		filePane = new JPanel();
		filePane.setLayout(new BoxLayout(filePane, BoxLayout.Y_AXIS));
		filePane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		filePane.add(file1);
		filePane.add(file2);
		pane.add(filePane);
		
		cut = new JLabel("Cut difference: " + c.getDifference(TargetFeature.Cut.ordinal()));
		shot = new JLabel("Shot difference: " + c.getDifference(TargetFeature.ShotType.ordinal()));
		clean = new JLabel("Clean difference: " + c.getDifference(TargetFeature.CleanType.ordinal()));
		motion = new JLabel("Motion difference: " + c.getDifference(TargetFeature.Motion.ordinal()));
		total = new JLabel("Total difference: " + c.getTotal());
		
		resultsPane = new JPanel();
		resultsPane.setLayout(new BoxLayout(resultsPane, BoxLayout.Y_AXIS));
		resultsPane.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		resultsPane.add(cut);
		resultsPane.add(shot);
		resultsPane.add(clean);
		resultsPane.add(motion);
		resultsPane.add(total);
		pane.add(resultsPane);
		
		add(pane);
		
		setSize(300,250);
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
}
