package comparer;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

public class CompareForm extends JFrame {
	JPanel pane;
	JLabel instructions;
	JLabel instructions2;
	JLabel instructions3;
	
	JPanel filePane1;
	JLabel fileLabel1;
	JTextField filename1;
	JButton openFile1;
	File file1 = null;
	
	JPanel filePane2;
	JLabel fileLabel2;
	JTextField filename2;
	JButton openFile2;
	File file2 = null;
	
	JPanel buttonPane;
	JButton submit;
	JButton exit;
//	String file1;
//	String file2;
	
	public CompareForm() {
		setTitle("Compare Files");
		instructions = new JLabel("Please enter the file names of the two lined scripts");
		instructions2 = new JLabel("to be compared.");
		instructions3 = new JLabel("Note: Files must be end in .json or .zip");
		
		fileLabel1 = new JLabel("File 1:");
		filename1 = new JTextField();
		filename1.setText("SampleTrainingSetFullLength.txt");
		Dimension d = filename1.getPreferredSize();
		filename1.setPreferredSize(new Dimension(d.width, d.height));
		filename1.setEditable(false);
		openFile1 = new JButton("Open File 1");
		filePane1 = new JPanel();
		filePane1.setLayout(new FlowLayout());
		filePane1.add(fileLabel1);
		filePane1.add(filename1);
		filePane1.add(openFile1);
		filePane1.setBorder(BorderFactory.createEmptyBorder(30,10,0,10));
		d = filePane1.getPreferredSize();
		filePane1.setPreferredSize(new Dimension(d.width, d.height));
		filename1.setText("Please select");
		
		fileLabel2 = new JLabel("File 2:");
		filename2 = new JTextField();
		filename2.setText("SampleTrainingSetFullLength.txt");
		d = filename2.getPreferredSize();
		filename2.setPreferredSize(new Dimension(d.width, d.height));
		filename2.setEditable(false);
		openFile2 = new JButton("Open File 2");
		filePane2 = new JPanel();
		filePane2.setLayout(new FlowLayout());
		filePane2.add(fileLabel2);
		filePane2.add(filename2);
		filePane2.add(openFile2);
		filePane2.setBorder(BorderFactory.createEmptyBorder(0,10,30,10));
		d = filePane2.getPreferredSize();
		filePane2.setPreferredSize(new Dimension(d.width, d.height));
		filename2.setText("Please select");
		
		submit = new JButton("Compare");
		exit = new JButton("Exit");
		
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(30,20,30,20));
		
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		pane.add(instructions);
		pane.add(instructions2);
		pane.add(instructions3);
		pane.add(filePane1);
		pane.add(filePane2);
		buttonPane = new JPanel();
		buttonPane.add(submit);
		buttonPane.add(exit);
		pane.add(buttonPane);
		add(pane);
		
		openFile1.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File[] files = getOpenFile();
						if (files.length==1)
							setFile1(files[0]);
						else if (files.length > 1) {
							setFile1(files[0]);
							setFile2(files[1]);
						}
					}
				}
				);
		
		openFile2.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File[] files = getOpenFile();
						if (files.length==1)
							setFile2(files[0]);
						else if (files.length > 1) {
							setFile1(files[0]);
							setFile2(files[1]);
						}
					}
				}
				);
		
		submit.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						if (file1 != null && file2 != null) {
							CompareUtil.compareFiles(file1, file2);
						}
						else {
							JOptionPane.showMessageDialog(null, "Please select two valid lined scripts.");
						}
					}
				}
				);
		exit.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						dispose();
					}
				}
				);
		setSize(520,320);
		setLocationRelativeTo(null);
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}

	public JPanel getPane() {
		return pane;
	}

	public void setPane(JPanel pane) {
		this.pane = pane;
	}

	public JLabel getInstructions() {
		return instructions;
	}

	public void setInstructions(JLabel instructions) {
		this.instructions = instructions;
	}

	public JTextField getFilename1() {
		return filename1;
	}

	public void setFilename1(JTextField filename1) {
		this.filename1 = filename1;
	}
	
	public JTextField getFilename2() {
		return filename1;
	}

	public void setFilename2(JTextField filename2) {
		this.filename2 = filename2;
	}

	public JButton getSubmit() {
		return submit;
	}

	public void setSubmit(JButton submit) {
		this.submit = submit;
	}
	
	private File[] getOpenFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("JSON Files", "json", "zip");
		fc.setFileFilter(filter);
		fc.setMultiSelectionEnabled(true);
		fc.setDialogTitle("Open Lined Script");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFiles();
		}
		else
			return null;
	}
	
	private void setFile1(File f1) {
		if (f1 != null) {
			if (f1.exists()) {
				file1 = f1;
				filename1.setText(f1.getName());
			}
			else {
				JOptionPane.showMessageDialog(null, "File not found.");
			}
		}
	}
	
	private void setFile2(File f2) {
		if (f2 != null) {
			if (f2.exists()) {
				file2 = f2;
				filename2.setText(f2.getName());
			}
			else {
				JOptionPane.showMessageDialog(null, "File not found.");
			}
		}
	}
}
