package comparer;

import java.util.ArrayList;
import java.util.HashMap;

import lister.TargetFeature;

public class Comparison {
	ArrayList<Double> dset1;
	ArrayList<Double> dset2;
	ArrayList<Double> difference;
	String file1 = null;
	String file2 = null;
	
	public Comparison() {
		dset1 = new ArrayList<Double>();
		dset2 = new ArrayList<Double>();
		difference = new ArrayList<Double>();
		for (TargetFeature tF: TargetFeature.values()) {
			dset1.add(0.0);
			dset2.add(0.0);
			difference.add(0.0);
		}
	}

	/**
	 * Calculates the difference
	 */
	public void calcDifference() {
		for (TargetFeature tF: TargetFeature.values()) {
			int ord = tF.ordinal();
			difference.set(ord, (dset1.get(ord) + dset2.get(ord))/2);
		}
	}
	
	public double getDifference(int ord) {
		return difference.get(ord);
	}
	
	public ArrayList<Double> getDifference() {
		return difference;
	}

	public void setDifference(ArrayList<Double> difference) {
		this.difference = difference;
	}
	
	public void setDifference(int ord, Double d) {
		difference.set(ord, d);
	}
	
	public double get(int ord) {
		return difference.get(ord);
	}
	
	public double getTotal() {
		double total = 0;
		for (TargetFeature tF: TargetFeature.values()) {
			total += difference.get(tF.ordinal());
		}
		return total;
	}

	public String getFile1() {
		return file1;
	}

	public void setFile1(String file1) {
		this.file1 = file1;
	}

	public String getFile2() {
		return file2;
	}

	public void setFile2(String file2) {
		this.file2 = file2;
	}

	public ArrayList<Double> getDset1() {
		return dset1;
	}

	public void setDset1(ArrayList<Double> dset1) {
		this.dset1 = dset1;
	}

	public void setDset1(int ord, double d) {
		dset1.set(ord, d);
	}
	
	public ArrayList<Double> getDset2() {
		return dset2;
	}

	public void setDset2(ArrayList<Double> dset2) {
		this.dset2 = dset2;
	}
	
	public void setDset2(int ord, double d) {
		dset2.set(ord, d);
	}
	
}
