package domain;

import java.awt.Color;
import java.util.ArrayList;
import java.util.LinkedList;

import com.fasterxml.jackson.annotation.JsonIgnore;

import util.Util;

public class ScriptObject {
	private Integer index;
	private String name;
	private LinkedList<Integer> scenes;
	private ScriptObjectType type;
	private ColorValue color;
	private Integer repeatOf;

	public ScriptObject() {
	}
	
	public ScriptObject(String name, Integer index) {
		this(name, index, ScriptObjectType.Unknown);
	}
	
	public ScriptObject(String name, Integer index, ScriptObjectType type) {
		this.index = index;
		this.name = name;
		scenes = new LinkedList<Integer>();
		color = Util.randomColor();
		this.type = type;
	}
	
	@JsonIgnore
	public Integer getIndex() {
		return index;
	}

	public void setIndex(Integer index) {
		this.index = index;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public LinkedList<Integer> getScenes() {
		return scenes;
	}
	public void setScenes(LinkedList<Integer> scenes) {
		this.scenes = scenes;
	}
	
	public void addScene(Integer scene) {
		int i = 0;
		for (i=0; i<scenes.size(); i++)
			if (scene.equals(scenes.get(i)))
				return;
			else if (scene < scenes.get(i)) {
				scenes.add(i, scene);
				return;
			}
		scenes.add(scene);
	}
	
	public String toString() {
		return name;
	}

	public ScriptObjectType getType() {
		return type;
	}

	public void setType(ScriptObjectType type) {
		this.type = type;
	}

	public ColorValue getColor() {
		return color;
	}

	public void setColor(ColorValue color) {
		this.color = color;
	}

	public Integer getRepeatOf() {
		return repeatOf;
	}

	public void setRepeatOf(Integer repeatOf) {
		this.repeatOf = repeatOf;
	}
	
	
	
}
