package domain;

import java.util.ArrayList;

public enum ShotType {
	ECU ("Extreme Close Up"),
	CU ("Close Up"),
	MCU ("Medium Close Up"),
	MS ("Medium Shot"),
	MWS ("Medium Wide Shot"),
	WS ("Wide Shot"),
	VWS ("Very Wide Shot"),
	EWS ("Extreme Wide Shot"),
	None ("If there is nothing being framed i.e. all black"),
	Other ("Anything not described");
	
	private final String name;       

    private ShotType(String s) {
        name = s;
    }
    
    public String getName() {
    	return name;
    }
    
    public static ArrayList<String> getStrings() {
    	ArrayList<String> v = new ArrayList<String>();
    	for (ShotType s: ShotType.values()) {
    		v.add(s.getName());
    	}
    	return v;
    }
    
    public static ArrayList<String> getValues() {
    	ArrayList<String> v = new ArrayList<String>();
    	for (ShotType s: ShotType.values()) {
    		v.add(s.toString());
    	}
    	return v;
    }
}
