package liner;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import parser.Parser;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.databind.JsonMappingException;

import util.FileUtil;
import domain.AllData;
import domain.Script;

public class FileForm extends JFrame {
	JPanel pane;
	JLabel instructions;
	JPanel filePane;
	JLabel fileLabel;
	JTextField filename;
	JLabel instructions2;
	JLabel instructions3;
	JButton submit;
	String file;
	
	public FileForm() {
		instructions = new JLabel("Please enter file name.");
		instructions2 = new JLabel("To start a new project: import a script ending in .txt");
		instructions3 = new JLabel("To continue a work in progress: import file ending in .json or .zip");
		fileLabel = new JLabel("File:");
		filename = new JTextField();
		filename.setText("SamplemoviescriptFullLength.txt");
		Dimension d = filename.getPreferredSize();
		filename.setPreferredSize(new Dimension(d.width, d.height));
		filePane = new JPanel();
		filePane.setLayout(new FlowLayout());
		filePane.add(fileLabel);
		filePane.add(filename);
		filePane.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		d = filePane.getPreferredSize();
		filePane.setPreferredSize(new Dimension(d.width, d.height));
		filename.setText("StarWarsLS.zip");
		submit = new JButton("Submit");
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		pane.add(instructions);
		pane.add(instructions2);
		pane.add(instructions3);
		pane.add(filePane);
		pane.add(submit);
		add(pane);
		
		submit.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						String filePath = filename.getText();
						String fileType = FileUtil.getFileType(filePath);
						if (fileType.equals("txt") || fileType.equals("json") || fileType.equals("zip")) {

							File f = new File(filePath);
							if (f.exists()) {
								dispose();
								String name = FileUtil.getName(filePath);
								AllData allData;
								
								if (fileType.equals("txt")) {
									ArrayList<String> text = FileUtil.readFile(filePath);

									Script script = Parser.textToScript(text, name);

									allData = LinerUtil.createDataLines(text, script);
									
									if(LinerUtil.recheckScriptObjects(allData))
										LinerUtil.updateDataLines(allData);

									final ScriptForm sForm = new ScriptForm(allData, Liner.linesPerPage);
									final ObjectForm oForm = new ObjectForm(allData, sForm);

									final MovieForm mForm = new MovieForm(script, sForm, oForm); //form);
								} 
								else {
									if (fileType.equals("json")) 
										allData = FileUtil.getAllDataFromJson(filePath);
									else 
										allData = FileUtil.getAllDataFromZip(filePath);
									
									final ScriptForm sForm = new ScriptForm(allData, Liner.linesPerPage);
									final ObjectForm oForm = new ObjectForm(allData, sForm);
									sForm.setVisible(true);
									oForm.setVisible(true);
								}
							}
							else 
								JOptionPane.showMessageDialog(null, "Can't find file " + filePath);
						}
						else 
							JOptionPane.showMessageDialog(null, "File must be of type .txt, .zip or .json");
					}
				}
				);
		setSize(450,250);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	public JPanel getPane() {
		return pane;
	}

	public void setPane(JPanel pane) {
		this.pane = pane;
	}

	public JLabel getInstructions() {
		return instructions;
	}

	public void setInstructions(JLabel instructions) {
		this.instructions = instructions;
	}

	public JTextField getFilename() {
		return filename;
	}

	public void setFilename(JTextField filename) {
		this.filename = filename;
	}

	public JButton getSubmit() {
		return submit;
	}

	public void setSubmit(JButton submit) {
		this.submit = submit;
	}
}
