package liner;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnore;

import domain.ShotType;
import domain.ScriptObject;
import domain.VisibleObject;

public class LineData {
	private int lineNum;
	private Integer sceneNum = null;
	private String timeCode;
	private boolean newShot;
	private int shotType;
	private int cleanType;
	private int motion;
	private String line;
	private List<VisibleObject> visibleObjects = new ArrayList<VisibleObject>();
	
	public LineData() {	
	}
	
	public LineData(String line, int lineNum) {
		this.lineNum = lineNum;
		newShot = false;
		shotType = 3;
		cleanType = 0;
		motion = 0;
		this.line = line.replace("\t","          ");
	}
	
	@JsonIgnore
	public int getLineNum() {
		return lineNum;
	}

	public void setLineNum(int lineNum) {
		this.lineNum = lineNum;
	}

	@JsonIgnore
	public Integer getSceneNum() {
		return sceneNum;
	}

	public void setSceneNum(Integer sceneNum) {
		this.sceneNum = sceneNum;
	}

	public String getTimeCode() {
		return timeCode;
	}

	public void setTimeCode(String timeCode) {
		this.timeCode = timeCode;
	}

	public boolean isNewShot() {
		return newShot;
	}

	public void setNewShot(boolean newShot) {
		this.newShot = newShot;
	}

	public int getShotType() {
		return shotType;
	}

	public void setShotType(int shotType) {
		this.shotType = shotType;
	}

	public int getCleanType() {
		return cleanType;
	}

	public void setCleanType(int cleanType) {
		this.cleanType = cleanType;
	}

	public int getMotion() {
		return motion;
	}

	public void setMotion(int motion) {
		this.motion = motion;
	}

	public String getLine() {
		return line;
	}

	public void setLine(String line) {
		this.line = line.replace("\t","          ");
	}

	public List<VisibleObject> getVisibleObjects() {
		return visibleObjects;
	}

	public void setVisibleObjects(List<VisibleObject> visibleObjects) {
		this.visibleObjects = visibleObjects;
	}
	
	public void removeVisibleObject(Integer objIndex) {
		int i;
		for (i=0; i<visibleObjects.size(); i++)
			if (objIndex.equals(visibleObjects.get(i).getObjectIndex())) {
				visibleObjects.remove(i);
				continue;
			}
		for (int j=0; j<visibleObjects.size(); j++)
			visibleObjects.get(j).setIndex(j);
	}
	
	public void addVisibleObject(Integer objIndex) {
		Integer i = 0;
		while ( i < visibleObjects.size()
				&& visibleObjects.get(i).getObjectIndex() <= objIndex) {
			if (objIndex == visibleObjects.get(i).getObjectIndex())
				return;
			i++;
		}
		visibleObjects.add(i, new VisibleObject(objIndex, false, visibleObjects.size(), lineNum));
		for (int j=0; j<visibleObjects.size(); j++)
			visibleObjects.get(j).setIndex(j);
	}
	
}
