package liner;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.filechooser.FileNameExtensionFilter;

import parser.Parser;
import util.FileUtil;
import domain.AllData;
import domain.Script;

public class LinerForm extends JFrame {
	JPanel pane;
	JLabel instructions;
	JLabel instructions2;
	JLabel instructions3;
	JButton newButton;
	JButton openButton;
	JPanel buttonPane;
	String file;
	
	public LinerForm() {
		this(false);
	}
	
	public LinerForm(boolean openedElsewhere) {
		setTitle("Script Liner Tool");
		
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(20,0,20,0));
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		instructions = new JLabel("Welcome to the Script Liner Tool.");
		instructions.setAlignmentX(JLabel.CENTER);
		instructions2 = new JLabel("Start a new project from a Script in txt format.");
		instructions2.setAlignmentX(JLabel.CENTER);
		instructions3 = new JLabel("Open an already lined script in json or zip format.");
		instructions3.setAlignmentX(JLabel.CENTER);
		pane.add(instructions);
		pane.add(instructions2);
		pane.add(instructions3);
		
		newButton = new JButton("New");
		openButton = new JButton("Open");
		buttonPane = new JPanel();
		buttonPane.setLayout(new FlowLayout());
		buttonPane.add(newButton);
		buttonPane.add(openButton);
		buttonPane.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		
		pane.add(buttonPane);
		add(pane);
		
		newButton.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File file = getScriptFile();
						if (file != null) {
							if (file.exists()) {
								String fileType = FileUtil.getFileType(file.getName());
								if (fileType.equals("txt")) {
									LinerUtil.openNewScriptForms(file, false);
									dispose();
								}
								else 
									JOptionPane.showMessageDialog(null, "Script must be of type .txt");
							}
							else 
								JOptionPane.showMessageDialog(null, "Can't find file " + file.getName());
						}
					}

				}
				);
		
		openButton.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File file = getLinedScriptFile();
						if (file!=null) {
							if (file.exists()) {
								String fileType = FileUtil.getFileType(file.getName());
								if (fileType.equals("json") || fileType.equals("zip")) {
									LinerUtil.openLoadScriptForms(file, false);
									dispose();
								}
								else 
									JOptionPane.showMessageDialog(null, "File must be of type .zip or .json");
							}
							else 
								JOptionPane.showMessageDialog(null, "Can't find file " + file.getName());
						}
					}

				}
				);
		setSize(500,200);
		setLocationRelativeTo(null);
		setVisible(true);
		if (openedElsewhere) {
			setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		}
		else
			setDefaultCloseOperation(EXIT_ON_CLOSE);
	}

	public JPanel getPane() {
		return pane;
	}

	public void setPane(JPanel pane) {
		this.pane = pane;
	}

	public JLabel getInstructions() {
		return instructions;
	}

	public void setInstructions(JLabel instructions) {
		this.instructions = instructions;
	}
	
	public File getLinedScriptFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("JSON Files", "json", "zip");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Load Lined Script");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {

			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		}
		else
			return null;
	}
	
	public File getScriptFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Text Files", "txt", "text");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Load New Script to Line");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		} 
		else
			return null;
	}
	
}
