package liner;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import util.Util;
import domain.Genre;
import domain.Script;

public class MovieForm extends JFrame {
	
//	final Form form;
	final ScriptForm sForm;
	final ObjectForm oForm;
	
	Script script;
	
	JPanel window = new JPanel();
	
	JPanel titlePane = new JPanel();
	JLabel titleLabel = new JLabel("Title");
	JTextField title = new JTextField();
	
	JPanel yearPane = new JPanel();
	JLabel yearLabel = new JLabel("Year");
	JTextField year;
	
	JPanel bwColorPane = new JPanel();
	ButtonGroup bwColor = new ButtonGroup();
	JLabel colorLabel = new JLabel("Color");
	JRadioButton color = new JRadioButton();
	JLabel bwLabel = new JLabel("B&W");
	JRadioButton bw = new JRadioButton();
	
	JPanel genrePane = new JPanel();
	JLabel genreLabel = new JLabel("Genre");
	JComboBox genre = new JComboBox(Genre.values());	
	
	JButton submit = new JButton("Submit");
	
	public MovieForm(Script script, ScriptForm s, ObjectForm o) { 
		this(script, s, o, false);
	}
		
	public MovieForm(Script script, ScriptForm s, ObjectForm o, boolean openedElsewhere) { 
		setTitle("Movie Information");
		sForm = s;
		oForm = o;
		
		this.script = script;
		
		window.setLayout(new BoxLayout(window, BoxLayout.Y_AXIS));
		
		titlePane.setLayout(new FlowLayout(FlowLayout.LEFT));
		title.setText("--Put Movie Title or TV Show and Episode Number here--");
		Dimension d = title.getPreferredSize();
	    title.setPreferredSize(new Dimension(d.width,d.height));
	    title.setText("");
		title.setToolTipText("--Put Movie Title or TV Show and Episode Number here--");
		titlePane.add(titleLabel);
		titlePane.add(title);
		
		yearPane.setLayout(new FlowLayout(FlowLayout.LEFT));
		year = new JTextField("--Year--");
		d = year.getPreferredSize();
		year.setPreferredSize(new Dimension(d.width,d.height));
		year.setText("");
		yearPane.add(yearLabel);
		yearPane.add(year);
		
		bwColorPane.setLayout(new FlowLayout(FlowLayout.LEFT));
		bwColor.add(color);
		bwColor.add(bw);
		color.setSelected(true);
		bwColorPane.add(colorLabel);
		bwColorPane.add(color);
		bwColorPane.add(bwLabel);
		bwColorPane.add(bw);
		
		genrePane.setLayout(new FlowLayout(FlowLayout.LEFT));
		genrePane.add(genreLabel);
		genrePane.add(genre);
		
		window.add(titlePane);
		window.add(yearPane);
		window.add(bwColorPane);
		window.add(genrePane);
		window.add(submit);
		window.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		
		submit.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						if(!title.getText().isEmpty()) {
							if (Util.isNumeric(year.getText())) {
								setValues();
								dispose();
//								form.setVisible(true);
								sForm.setVisible(true);
								oForm.setVisible(true);
							}
							else {
								JOptionPane.showMessageDialog(null, "Please enter a valid year.");
							}
						}
						else {
							JOptionPane.showMessageDialog(null, "Please enter the title.");
						}
					}
				}
				);
		
		add(window);
		
		setSize(450,300);
		setLocationRelativeTo(null);
		setVisible(true);
		if (openedElsewhere) {
			setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		}
		else
			setDefaultCloseOperation(EXIT_ON_CLOSE);
	}

	public void setValues() {
		script.setTitle(title.getText());
		script.setYear(Integer.parseInt(year.getText()));
		script.setColor(color.isSelected());
		script.setGenre(Genre.values()[genre.getSelectedIndex()]);
	}
}
