package liner;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;
public class TipRenderer extends DefaultListCellRenderer {
    ArrayList<String> tips;

    @Override
    public Component getListCellRendererComponent(JList list, Object value,
                        int index, boolean isSelected, boolean cellHasFocus) {

        JComponent comp = (JComponent) super.getListCellRendererComponent(list,
                value, index, isSelected, cellHasFocus);

        if (-1 < index && null != value && null != tips) {
                    list.setToolTipText(tips.get(index));
                }
        return comp;
    }

    public void setTips(ArrayList<String> t) {
    	tips = t;
    }
    
    public void addTip(String tip) {
    	tips.add(tip);
    }
}
