package lister;

/**
 * Enum of all the features
 * 
 * @author David Smith
 *
 */
public enum Features {
	//non-pure:
	cut("cut", false),
	shotType("shot type", false),
	cleanType("clean type", false),
	motions("motions", false),
	linesSinceCut("lines since cut", false),
	linesSinceShotTypeChange("lines since shot type change", false),
	lastShotTypeNoCut("last shot type", false),
	lastShotTypeWhenCut("last shot type when cut", false),
	linesSinceCleanChange("lines since clean type change", false),
	lastCleanType("clean type on previous line", false),
	linesSinceMotionChange("lines since motion change", false),
	lastMotionType("last motion type", false),
	tiltCount("number of lines while tilt", false),
	zoomCount("number of lines while zoom", false),
	panCount("number of lines while pan", false),
	dialogueCountInShot("dialogue blocks in the shot", false),
	uniqueDialogueCountInShot("unique dialogue blocks in the shot", false),
	actionCountInShot("action blocks in the shot", false),
	lineCountInShot("the length in lines of the shot", false),
	//pure:
	sceneObjectType("scene object type", true),
	linesSinceObjectChange("lines since scene object change", true),
	linesSinceNewScene("lines since new scene", true),
	intExt("interior or exterior scene", true),
	scriptObjectsInScene("script objects in scene", true),
	actionBlocksInScene("action blocks in scene", true),
	dialogueBlocksInScene("dialogue blocks in scene", true),
	sceneLength("scene length", true);
	
	String name;
	boolean pure;
	
	private Features(String name, boolean pure) {
		this.name=name;
		this.pure=pure;
	}
	
	public String getName() {
		return name;
	}
	
	public boolean isPure() {
		return pure;
	}
	
	/*
	 * Possible features to add in the future:
	 * non-pure:
	 * 
	 * numberOfShotChanges "number of times a shot type has changed during a shot"
	 * numberOfCleanChanges "number of times a clean type has changed during a shot"
	 * numberOfMotionChanges "number of times a motion has changed during a shot"
	 * shotsInScene
	 * charactersMentionedInShot
     * shotsInSceneSoFar
     * dialogueCountInShotSoFar
     * uniqueDialgoueCountInShotSoFar
     * actionCountInShotSoFar
     * lineCountInShotSoFar
	 * 
	 * pure:
	 * sceneNumber,
	 * charactersInScene,
	 * charactersOnLine,
	 * objectsOnLine
	 */
}
