package lister;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

import util.FileUtil;
import liner.LinerUtil;

public class ListerForm extends JFrame {
	JPanel pane;
	JLabel instructions;
	JPanel filePane;
	JLabel fileLabel;
	JTextField filename;
	JPanel outputPane;
	JLabel outputLabel;
	JTextField outputname;
	JPanel vectorPane;
	JLabel vectorLabel;
	JTextField vectorname;
	JLabel instructions2;
	JLabel instructions3;
	JButton script;
	JButton output;
	JButton vector;
	JButton submit;
	JButton features;
	JPanel buttonPane;
	JCheckBox openLiner;
	JLabel openLabel;
	JPanel openPane;
	String file;
	FeatureSettings settings = new FeatureSettings();
	File scriptFile;
	File outputFile;
	File vectorFile;
	
	public ListerForm() {
		this(false);
	}
	
	public ListerForm(boolean openedElsewhere) {
		setTitle("Shot Lister");
		instructions = new JLabel("Please select the Script To Create a Shot List For.");
		instructions2 = new JLabel("Also select output and vector file.");
		instructions3 = new JLabel("The output will be a zipped .json");
		
		fileLabel = new JLabel("Script File:");
		filename = new JTextField();
		filename.setText("SampleTrainingSetFullLength.txt");
		Dimension d = filename.getPreferredSize();
		filename.setPreferredSize(new Dimension(d.width, d.height));
		script = new JButton("Select Script");
		filePane = new JPanel();
		filePane.setLayout(new FlowLayout());
		filePane.add(fileLabel);
		filePane.add(filename);
		filePane.add(script);
		filePane.setBorder(BorderFactory.createEmptyBorder(5,20,2,20));
		d = filePane.getPreferredSize();
		filePane.setPreferredSize(new Dimension(d.width, d.height));
		filename.setText("Please select script");
		filename.setEditable(false);
		
		outputLabel = new JLabel("Output File:");
		outputname = new JTextField();
		outputname.setText("SampleTrainingSetFullLength.txt");
		d = outputname.getPreferredSize();
		outputname.setPreferredSize(new Dimension(d.width, d.height));
		output = new JButton("Select Output");
		outputPane = new JPanel();
		outputPane.setLayout(new FlowLayout());
		outputPane.add(outputLabel);
		outputPane.add(outputname);
		outputPane.add(output);
		outputPane.setBorder(BorderFactory.createEmptyBorder(2,20,2,20));
		d = outputPane.getPreferredSize();
		outputPane.setPreferredSize(new Dimension(d.width, d.height));
		outputname.setText("Please select output");
		outputname.setEditable(false);
		
		vectorLabel = new JLabel("Vector File:");
		vectorname = new JTextField();
		vectorname.setText("SampleTrainingSetFullLength.txt");
		d = vectorname.getPreferredSize();
		vectorname.setPreferredSize(new Dimension(d.width, d.height));
		vector = new JButton("Select Vector");
		vectorPane = new JPanel();
		vectorPane.setLayout(new FlowLayout());
		vectorPane.add(vectorLabel);
		vectorPane.add(vectorname);
		vectorPane.add(vector);
		vectorPane.setBorder(BorderFactory.createEmptyBorder(2,20,5,20));
		d = vectorPane.getPreferredSize();
		vectorPane.setPreferredSize(new Dimension(d.width, d.height));
		vectorFile = new File(Constants.DEFAULTVECTORNAME);
		if (vectorFile.exists()) {
			vectorname.setText(vectorFile.getName());
		}
		else {
			vectorFile = null;
			vectorname.setText("Please select vector file");
		}
		vectorname.setEditable(false);
		
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
		
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		pane.add(instructions);
		pane.add(instructions2);
		pane.add(instructions3);
		pane.add(filePane);
		pane.add(outputPane);
		pane.add(vectorPane);
		
		openPane = new JPanel();
		openLabel = new JLabel("Open results in Liner Tool");
		openLiner = new JCheckBox();
		openLiner.setSelected(true);
		openPane.setLayout(new FlowLayout());
		openPane.add(openLabel);
		openPane.add(openLiner);
		
		buttonPane = new JPanel();
		submit = new JButton("Submit");
		features = new JButton("Customize Features");
		buttonPane.setLayout(new FlowLayout());
		buttonPane.add(features);
		buttonPane.add(submit);
		pane.add(buttonPane);
		pane.add(openPane);
		add(pane);
		
		script.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File file = getScriptFile();
						setScript(file);
					}
				}
				);
		
		output.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File file = getOutFile();
						setOutput(file);
					}
				}
				);
		
		vector.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File file = getVectorFile();
						setVector(file);
					}
				}
				);
		features.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						FeatureForm fF = new FeatureForm(settings);
					}
				}
				);
		submit.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						ListerUtil.getShotList(scriptFile, outputFile, vectorFile, settings, openLiner.isSelected());
					}

				}
				);
		setSize(550,320);
		setLocationRelativeTo(null);
		setVisible(true);
		if (openedElsewhere) 
			setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		else
			setDefaultCloseOperation(EXIT_ON_CLOSE);
	}

	public JPanel getPane() {
		return pane;
	}

	public void setPane(JPanel pane) {
		this.pane = pane;
	}

	public JLabel getInstructions() {
		return instructions;
	}

	public void setInstructions(JLabel instructions) {
		this.instructions = instructions;
	}

	public JTextField getFilename() {
		return filename;
	}

	public void setFilename(JTextField filename) {
		this.filename = filename;
	}

	public JButton getSubmit() {
		return submit;
	}

	public void setSubmit(JButton submit) {
		this.submit = submit;
	}
	
	public File getScriptFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Text Files", "txt", "text");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Load New Script to Auto Line");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		} 
		else
			return null;
	}
	
	public File getOutFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("ZIP", "zip");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Choose name of output file");
		fc.setApproveButtonText("New");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		} 
		else
			return null;
	}
	
	public File getVectorFile() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("JSON Files", "json");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Load Vector File");
		fc.setApproveButtonText("Open");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFile();
		} 
		else
			return null;
	}
	
	public void setScript(File scriptFile) {
		if (scriptFile != null) {
			if (scriptFile.exists()) {
				this.scriptFile = scriptFile;
				filename.setText(scriptFile.getName());
				setOutput(getDefaultOutput(scriptFile));
			}
			else {
				JOptionPane.showMessageDialog(null, "Script file not found.");
			}
		}
	}
	
	public File getDefaultOutput(File input) {
		String name = input.getName();
		String base = FileUtil.getName(name);
		return new File(base + "LS.zip");
	}
	
	public void setOutput(File outputFile) {
		if (outputFile != null) {
			this.outputFile = outputFile;
			outputname.setText(outputFile.getName());
		}
	}
	
	public void setVector(File vectorFile) {
		if (vectorFile != null) {
			if (vectorFile.exists()) {
				this.vectorFile = vectorFile;
				vectorname.setText(vectorFile.getName());
			}
			else {
				JOptionPane.showMessageDialog(null, "Vector file not found.");
			}
		}
	}
}
