package lister;

import java.io.File;

import javax.swing.JOptionPane;

import liner.LinerUtil;

public class ListerUtil {
	public static void getShotList(File scriptFile, File outputFile, File vectorFile, 
			FeatureSettings settings, boolean openInLiner) {
		if (scriptFile == null) {
			JOptionPane.showMessageDialog(null, "Please select a script.");
		}
		else if (outputFile == null) {
			JOptionPane.showMessageDialog(null, "Please select an output file name.");
		}
		else if (vectorFile == null) {
			JOptionPane.showMessageDialog(null, "Please select a valid vector file.");
		}
		else {
			String filePath = scriptFile.getAbsolutePath();
			String outPath = outputFile.getAbsolutePath();
			String vectorPath = vectorFile.getAbsolutePath();
			String returnName = VectorUtil.scriptFileToAllDataFile(filePath, outPath, vectorPath, settings);
			if (returnName != null) {
				if (openInLiner)
					LinerUtil.openLoadScriptForms(new File(returnName), true);
			}
		}
	}
}
