package lister;

import java.util.ArrayList;

import domain.CutOptions;
import domain.ShotType;

/**
 * Enum of all of the target features
 * 
 * @author David Smith
 *
 */
public enum TargetFeature {
	Cut("Cut", CutOptions.getStrings()),
	ShotType("ShotType", domain.ShotType.getValues()),
	CleanType("CleanType", domain.CleanType.getValues()),
	Motion("Motion", domain.Motion.getStrings());
	
	private final String name; 
	private final ArrayList<String> options;

    private TargetFeature(String name, ArrayList<String> options) {
        this.name = name;
        this.options = options;
    }
    
    public String getName() {
    	return name;
    }
    
    public ArrayList<String> getOptions() {
    	return options;
    }
    
    public static ArrayList<String> getStrings() {
    	ArrayList<String> v = new ArrayList<String>();
    	for (TargetFeature s: TargetFeature.values()) {
    		v.add(s.getName());
    	}
    	return v;
    }
}
