package lister;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.filechooser.FileNameExtensionFilter;

public class VPopulateForm extends JFrame {
	JPanel pane;
	JLabel instructions;
	JPanel filePane;
	JLabel fileLabel;
	JTextField vectorFilename;
	JLabel instructions2;
	JLabel instructions3;
	JPanel instructionPane;
	JPanel buttonPane;
	JButton openLister;
	JButton add;
	String file;
	
	public VPopulateForm() {
		setTitle("Vector Populator");
		instructions = new JLabel("Please enter file name of the json Vector file to add to.");
		instructions2 = new JLabel("Note: if Vector file doesn't exist yet, it will be created.");
		instructions3 = new JLabel("Then add training sets with file ending in .json or .zip");
		fileLabel = new JLabel("Vector File:");
		vectorFilename = new JTextField();
		vectorFilename.setText("SampleTrainingSetFullLength.txt");
		Dimension d = vectorFilename.getPreferredSize();
		vectorFilename.setPreferredSize(new Dimension(d.width, d.height));
		filePane = new JPanel();
		filePane.setLayout(new FlowLayout());
		filePane.add(fileLabel);
		filePane.add(vectorFilename);
		filePane.setBorder(BorderFactory.createEmptyBorder(20,0,20,0));
		d = filePane.getPreferredSize();
		filePane.setPreferredSize(new Dimension(d.width, d.height));
		vectorFilename.setText(Constants.DEFAULTVECTORNAME);
		buttonPane = new JPanel();
		openLister = new JButton("Open Lister");
		add = new JButton("Add Training Set[s]");
		buttonPane.add(add);
		buttonPane.add(openLister);
		pane = new JPanel();
		pane.setBorder(BorderFactory.createEmptyBorder(20,0,20,0));
		instructionPane = new JPanel();
		instructionPane.setLayout(new BoxLayout(instructionPane, BoxLayout.Y_AXIS));
		instructionPane.add(instructions);
		instructionPane.add(instructions2);
		instructionPane.add(instructions3);
		pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		pane.add(instructionPane);
		pane.add(filePane);
		pane.add(buttonPane);
		add(pane);
		
		openLister.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						ListerForm lForm = new ListerForm(true);
					}
				}
				);
		
		add.addActionListener(
				new ActionListener(){
					@Override
					public void actionPerformed(
							ActionEvent e){
						File[] files = getFileNames();
						if (files != null) {
							ArrayList<String> added = new ArrayList<String>();
							for (File file: files) {
								String fileName = file.getName();
								System.out.println(fileName);
								if (VectorUtil.populateVectorsFile(file, vectorFilename.getText()))
									added.add(file.getName());
							}
							if (added.size() > 0) {
								JOptionPane.showMessageDialog(null, added + " added to "+ vectorFilename.getText());
							}
						}
							
					}
				}
				);
		
		setSize(500,250);
		setLocationRelativeTo(null);
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}

	public JPanel getPane() {
		return pane;
	}

	public void setPane(JPanel pane) {
		this.pane = pane;
	}

	public JLabel getInstructions() {
		return instructions;
	}

	public void setInstructions(JLabel instructions) {
		this.instructions = instructions;
	}

	public JTextField getFilename() {
		return vectorFilename;
	}

	public void setFilename(JTextField filename) {
		this.vectorFilename = filename;
	}

	public JButton getSubmit() {
		return openLister;
	}

	public void setSubmit(JButton submit) {
		this.openLister = submit;
	}
	
	private File[] getFileNames() {
		JButton open = new JButton();
		JFileChooser fc = new JFileChooser();
		fc.setMultiSelectionEnabled(true);
		fc.setCurrentDirectory(new java.io.File("."));
		FileNameExtensionFilter filter = new FileNameExtensionFilter("JSON Files", "json", "zip");
		fc.setFileFilter(filter);
		fc.setDialogTitle("Add Training Set");
		if (fc.showOpenDialog(open) == JFileChooser.APPROVE_OPTION) {
			fc.getCurrentDirectory();
			return fc.getSelectedFiles();
		}
		else
			return null;
	}
}
