/**
 * Parser Tool
 * 
 * Reads in a script as argument (or defaults to Ghostbusters in the resources folder)
 * 
 * Outputs a json
 * 
 * @author David Smith
 */
package parser;

import java.util.ArrayList;

import util.FileUtil;
import domain.Script;

public class ParserTool {

	public static void main(String[] args) throws Exception {
		String filePath;
		if (args.length > 1)
			filePath = args[1];
		else
			filePath = "resources\\Ghostbusters.txt";
		String name = FileUtil.getName(filePath);
		ArrayList<String> text = FileUtil.readFile(filePath);
		Script script = Parser.textToScript(text, name);
		script.setTitle(name);
		String fileName;
		if (args.length > 2)
			fileName = args[2];
		else
			fileName = "resources\\" + name + ".json";
		String output = FileUtil.toJsonString(script);
		FileUtil.writeFile(fileName + ".json", output);
	}
}
