package test;

import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

import util.FileUtil;
import util.Util;
import domain.Scene;

public class TestUtils {
	
	@Test
	public void readTheFile() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		System.out.println(lines.get(0));
		assertEquals("FADE IN:", lines.get(0));
	}
	
	@Test
	public void checksBlanknessOfALine() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		for (String line: lines)
			if(Util.isBlank(line))
				System.out.println("blank");
			else
				System.out.println("not blank");
		assertTrue(Util.isBlank(lines.get(1)));
	}
	
	@Test
	public void tellsIfALineIsAScene() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		for (String line: lines)
			if(Util.isScene(line))
				System.out.println("A Scene Marker");
			else
				System.out.println("Not a new scene");
		assertTrue(Util.isScene(lines.get(2)));
	}
	
	@Test
	public void tellsIfALineIsAllUpper() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		for (String line: lines)
			if(Util.isAllUpper(line))
				System.out.println("All uppercase line");
			else
				System.out.println("Not all uppercase");
		assertTrue(Util.isAllUpper(lines.get(0)));
	}
	
	@Test
	public void tellsIfALineIsMostlyUpper() {
		String line = "I AM A MAN IS MOSTLY ALL IN a GOOD MOOD";
		assertTrue(Util.isMostlyUpper(line, .95));
	}
	
	@Test
	public void checkIfALineIsACharacter() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		for (int i=0; i<lines.size(); i++) {
			if(i>0 && i+1<lines.size()) {
				if(Util.isCharacter(lines, i, lines.size()))
					System.out.println("This is a character name.");
				else
					System.out.println("Not a character name.");
			}
		}
		assertTrue(Util.isCharacter(lines, 6, lines.size()));
	}
	
	@Test
	public void checkIfTransistion() {
		ArrayList<String> lines = FileUtil.readFile("resources/extra/ScriptTest.txt");
		for (int i=0; i<lines.size(); i++) {
			if(i>0 && i+1<lines.size()) {
				if(Util.isTransition(lines.get(i), lines.get(i-1), lines.get(i+1)))
					System.out.println("This line is a transition");
				else
					System.out.println("not a transistion");
			}
		}
	}
	
	@Test
	public void sceneLineIsParsed() {
		String sceneString = "INT. MY FRIEND'S BACKYARD - NIGHT";
		Scene scene = Util.parseSceneString(sceneString);
		System.out.println(scene.toString());
		assertEquals("INT.", scene.getWhere());
		assertEquals("NIGHT", scene.getWhen());
	}
	
	@Test
	public void getUpperWords() {
		String sceneString = "A MAN was jumping when SHOT DOWN he heard a BLAST from next door.";
		ArrayList<String> upperWords = Util.getUpperWords(sceneString);
		System.out.println(upperWords);
		assertEquals(3, upperWords.size());
		assertEquals("MAN", upperWords.get(0));
	}
	
	@Test
	public void verifyShotIncrease() {
		String count = "A";
		String up = Util.increaseShot(count);
		System.out.println(count + " to " + up);
		assertEquals("B", up);
		count = "Z";
		up = Util.increaseShot(count);
		System.out.println(count + " to " + up);
		assertEquals("AA", up);
		count = "AG";
		up = Util.increaseShot(count);
		System.out.println(count + " to " + up);
		assertEquals("AH", up);
		count = "DZ";
		up = Util.increaseShot(count);
		System.out.println(count + " to " + up);
		assertEquals("EA", up);
		count = "ZZ";
		up = Util.increaseShot(count);
		System.out.println(count + " to " + up);
		assertEquals("AAA", up);
	}
	
	String line = "3   INT. ENTERPRISE BRIDGE - ANOTHER ANGLE                       3";
	
	@Test
	public void firstAndLastNumber() {
		assertTrue(Util.isFirstAndLastNum(line));
	}
	
	@Test
	public void removeIt() {
		String removed = Util.removeFirstAndLastNum(line);
		System.out.println(removed);
	}
	
	@Test
	public void isThisASceneToo() {
		assertTrue(Util.isScene(line));
	}
	
	String line2 = "FADE IN: INT. ANTEROOM CLOSE SHOT SWITCHBOARD";
	
	@Test
	public void embeddedScene() {
		assertTrue(Util.isScene(line2));
	}
}
